*!*	----------------------------------------
*!*	Bang ke thue VAT dau vao
*!*	Nguoi lap trinh: HUNGPN
*!*	Ngay lap trinh: 25/06/2001
*!*	----------------------------------------

PARAMETER m.Dbf, m.MauI, pMau_bc
	IF .F.
		_REFOX_ = (9876543210)
	ENDIF

	* + Gan bien
	m.Rep_vnd_nt1 = m_Rep_vnd_nt
	m.Thang = MONTH(DATE())
	m.Thang1 = MONTH(DATE())
	m.Thang2 = MONTH(DATE())
	M.year = year(date())
	m.Nhan_huy = 1
	
	m.Tk = "133"
	m.Tk_du = ""
	M.Ma_thue = ""
	m.Thue_suat = ""
	m.Order = "NGAY_CT"
	
	USE (k_cod + "dmtk" + m_nam) ORDER Tk ALIAS m_Dmtk NOUPDATE IN 0
	DO FORM (k_scx + "glthue1")
	USE IN m_Dmtk
	IF m.Nhan_huy <> 1
		RETURN
	ENDIF
	if M.Thang>M.Thang2
		messagebox("Nhap thang khong hop le!")
	endif

	m.Tk = ALLT(m.Tk)
	m.Tk_Du = ALLT(m.Tk_Du)
	m.Mau_bc = ALLT(m.Mau_bc)
	
	WAIT m_Process WINDOW NOWAIT
	
	DO FilterData
	
	WAIT CLEAR
	DO BrowseTable
RETURN

*!*	----------------------------------------
*!*	PROCEDURE FilterData
*!*	----------------------------------------
PROCEDURE FilterData
#DEFINE _STRING_TOTAL "Tng pht sinh"
	_Key = "MONTH(Ngay_ct) >= m.Thang and MONTH(Ngay_ct) <= m.Thang2"
	
	IF NOT EMPTY(m.Tk)
		IF NOT ("%" $ m.Tk) OR NOT ("_" $ m.Tk)
			m.Tk = ALLT(m.Tk) + "%"
		ENDIF
		_Key = _Key + " AND (Tk_thue_no LIKE m.Tk)"
	ENDIF
	

	IF NOT EMPTY(m.Thue_suat)
		m.Thue_suat = STRTRAN(ALLTRIM(m.Thue_suat), " ", "")
		_Key = _Key + " AND Thue_suat = " + STRTRAN(ALLTRIM(m.Thue_suat), "," , " OR Thue_suat = ")
	ENDIF
		
	IF NOT EMPTY(m.Tk_du)
		IF NOT ("%" $ m.Tk_du) OR NOT ("_" $ m.Tk_du)
			m.Tk_du = ALLT(m.Tk_du) + "%"
		ENDIF
		_Key = _Key + "AND (Tk_du LIKE m.Tk_du)"
	ENDIF
	

	USE (k_dbf + m.Dbf + m_nam) ALIAS k_gt NOUPDATE IN 0

	SELECT *,space(1)as Stt, "2" AS Ct ,'2'AS FSort,Space(128)AS Dien_giai;
		WHERE &_Key ;
		FROM k_gt ;
		INTO DBF (k_tmp + "tThuetmp")
	
	SELECT tThueTmp
	
	INDEX ON Nhom+Ma_ct+ padl(allt(So_ct),10,'0') + DTOS(Ngay_ct)+ str(mau_bc) TAG Stt
	
	&&USE IN tThuetmp
ENDPROC

*!*	----------------------------------------
*!*	PROCEDURE BrowseTable
*!*	----------------------------------------
PROCEDURE BrowseTable
	SELECT tThuetmp
	&&USE (K_Tmp+"tThueTmp") ORDE Stt asce
	ON KEY LABEL F5 DO Check
	ON KEY LABEL F7 DO ToExcel
	ON KEY LABEL F10 DO Option
	_Title = "Bang ke chung tu thue GTGT dau vao" + ". F5 - Kiem tra, F7 - Chuyen Excel, F10 - Sap xep, Esc - Quay ra"
	sDynamicBackColor = "IIF(EMPTY(Ngay_Ct),RGB(230,251,235),RGB(255,255,255))"

	BROWSE FIELDS;
			Nhom,;
			Ma_ct,;
			So_ct,;
			Ngay_ct,;
			So_seri0: 10, ;
			So_ct0: 12, ;
			Ngay_ct0:H="Ngay HD":12,;
			Ten_kh: 30, ;
			Dia_chi: 40, ;
			Ma_so_thue: 15, ;
			Ten_vt:30,;
			T_tien: P = "@Z" + m_Ip_Tien, ;
			T_thue: P = "@Z" + m_Ip_Tien, ;
			Thue_suat: P = "@Z 999.99", ;
			Ma_hdon,;
			KH_MHD,;
			Ghi_chu: 40;
		NAME oBrowse NOWAIT;
		WHEN Change_color_of_Browse(RECNO(), sDynamicBackColor) ;
		WINDOW m_WinBrw TITLE _Title
	DO HookObjectBrowse
	
	BROWSE LAST
	USE IN tThuetmp
	ON KEY LABEL F5
	ON KEY LABEL F7
	ON KEY LABEL F10
ENDPROC


	

*!*	----------------------------------------
*!*	PROCEDURE Print
*!*	----------------------------------------
PROCEDURE Print
	SET FILTER TO (Ct = "2" AND T_Tien#0 ) OR Fsort='1'
	IF pMau_bc == "5"
		m.frx = "5a"
	ELSE
		m.frx = m.Mau_bc
	ENDIF
	DO Pr_Report
	SET FILTER TO
RETURN
	
*!*	----------------------------------------
*!*	PROCEDURE Option
*!*	----------------------------------------
PROCEDURE Option
	PUSH KEY CLEAR
	DO FORM (K_Scx + "glthue1f10") 
	POP KEY
	SELECT tThueTmp
	SET ORDER TO m.Order
RETURN

*!*	----------------------------------------
*!*	PROCEDURE Check
*!*	----------------------------------------
PROCEDURE Check
PRIVATE oBrowse
	IF EMPTY(Ngay_ct0)
		RETURN
	ENDIF
	
	PUSH KEY CLEAR
	SELECT ;
			Stt_rec, ;
			LEFT(Tk_thue_no, 3) AS Tk_thue, ;
			SUM(T_thue) AS T_thue ;
		FROM tThueTmp ;
		GROUP BY Stt_rec, Tk_thue ;
		ORDER BY Stt_rec, Tk_thue ;
		INTO TABLE (k_tmp + "tCheck");
			
	USE (k_dbf + "ct00" + m_nam) ORDER stt_rec NOUPDATE ALIAS k_ct00 IN 0

	SELECT ;
			Stt_rec, ;
			LEFT(Tk, 3) AS Tk_thue, ;
			SUM(Ps_no) AS T_thue0, ;
			m_P_tien AS t_thue, ;
			Ma_ct, ;
			So_ct, ;
			Ngay_ct, ;
			Dien_giai, ;
			Ma_kh, ;
			SPACE(1) AS Tag;
		FROM k_Ct00 ;	
		WHERE Stt_rec IN (SELECT Stt_rec FROM tCheck) ;
				AND LEFT(Tk, 3) IN (SELECT DISTINCT Tk_thue FROM tCheck);
		GROUP BY stt_rec, tk_thue ;
		ORDER BY stt_rec, tk_thue ;		
		INTO TABLE (k_tmp + "Check")
		
	USE IN k_ct00
		
	SELECT tCheck
	INDEX ON Stt_rec + Tk_thue TAG Stt
	
	SELECT Check
	SCAN
		IF NOT SEEK(Stt_rec + Tk_thue, "tCheck")
			REPLACE Tag WITH "x"
		ELSE
			IF T_thue0 <> tCheck.T_thue
				REPLACE Tag WITH "x", T_thue WITH tCheck.T_thue
			ENDIF
		ENDIF
	ENDSCAN
	
	SELECT * ;
		FROM Check;
		WHERE NOT EMPTY(Tag);
		INTO TABLE (k_tmp + "tWrong")
	
	IF _TALLY > 0
		BROWSE FIELDS Ma_ct, So_ct, Ngay_ct, ;
				Dien_giai :24, Ma_kh, Tk_thue, ;
				T_thue0: P = "@Z" + m_Ip_Tien, ;
				T_thue: P= "@Z" + m_Ip_Tien ;
			NAME oBrowse ;
			WHEN Change_Color_Of_Browse(RECNO());
			NOAPPEND NOMODIFY NODELETE;
			WINDOW m_WinBrw TITLE "Danh sach cac ctu loi ve so tien thue"
	ENDIF
	USE IN tWrong
	USE IN Check
	USE IN tCheck
	POP KEY
RETURN

*!*	----------------------------------------
*!*	PROCEDURE ToExcel
*!*	----------------------------------------
PROCEDURE ToExcel
	WAIT window "Dang thuc hien ..." nowait
	LOCAL liRowIndex, liColumnIndex, lcAlias
	lcCursor  = ALIAS() && table or cursor name
	SELECT ( lcCursor )
	loExcelSession = CREATEOBJECT('Excel.Application')

	WITH loExcelSession
	   .Visible  = .T.
	   .DisplayAlerts = .F.   && no messages displayed
	ENDWITH
	
	_filexl = 'MAUMV320.xls'
	_file = "C:\EXCEL\" + _filexl
	IF file(_file)
		_Temopen = _file
	ELSE
		_file = "D:\EXCEL\" + _filexl
		IF file(_file)
			_Temopen = _file
		ELSE
			_file = "E:\EXCEL\" + _filexl
			IF file(_file)
				_Temopen = _file
			ELSE
				_Temopen = FULLPATH(M_root) + 'Excel\' + _filexl
			ENDIF
		ENDIF	
	ENDIF
	
	oExcelWorkbook = loExcelSession.APPLICATION.Workbooks.OPEN(_Temopen) 
	oActiveExcelSheet = oExcelWorkbook.Worksheets(1).ACTIVATE
	XLSHEET = oExcelWorkbook.Worksheets(1)
	
	
	i = 17
	k = 18
	n=0
	
	SELECT tThueTmp
	count to t1 for allt(nhom)=='1'
	count to t2 for allt(nhom)=='2'
	count to t3 for allt(nhom)=='3'
	count to t4 for allt(nhom)=='4'
	count to t5 for allt(nhom)=='5'
	
	d1=0
		
	SELECT tThueTmp
	SCAN for allt(nhom) = '1'
		i=i+1
		n=n+1
		
		if i>18 and d1 <t1
			d1 = d1 + 1
			CROW = ALLTRIM(STR(i))
		    XlSheet.Rows("&cRow:&cRow").Insert
		endif
		
		XLSHEET.CELLS(i,2).VALUE = "'"+allt(str(n))
		XLSHEET.CELLS(i,3).VALUE = allt(Ma_hdon)
		XLSHEET.CELLS(i,4).VALUE = allt(kh_mhd)
		XLSHEET.CELLS(i,5).VALUE = allt(so_seri0)
		XLSHEET.CELLS(i,6).VALUE = "'"+allt(so_ct0)
		XLSHEET.CELLS(i,7).VALUE = ngay_ct0
		XLSHEET.CELLS(i,8).VALUE = Allt(Ten_kh)
		XLSHEET.CELLS(i,9).VALUE = "'"+allt(Ma_so_thue)
		XLSHEET.CELLS(i,10).VALUE = allt(Ten_vt)
		XLSHEET.CELLS(i,11).VALUE = t_tien
		XLSHEET.CELLS(i,12).VALUE = thue_suat
		XLSHEET.CELLS(i,13).VALUE = t_thue
		XLSHEET.CELLS(i,14).VALUE = allt(ghi_chu)
	ENDSCAN
	
	n=0

	k = 18 + d1 + 3
	i = 17 + d1 + 3
	p = i
	q = k
	d2 = 0
	
	SELECT tThueTmp
	SCAN for allt(nhom) = '2'
		i=i+1
		n=n+1
		
		if i>k and d2 < t2
			d2 = d2 + 1
			CROW = ALLTRIM(STR(i))
		    XlSheet.Rows("&cRow:&cRow").Insert
		endif
		
		XLSHEET.CELLS(i,2).VALUE = "'"+allt(str(n))
		XLSHEET.CELLS(i,3).VALUE = allt(Ma_hdon)
		XLSHEET.CELLS(i,4).VALUE = allt(kh_mhd)
		XLSHEET.CELLS(i,5).VALUE = allt(so_seri0)
		XLSHEET.CELLS(i,6).VALUE = "'"+allt(so_ct0)
		XLSHEET.CELLS(i,7).VALUE = ngay_ct0
		XLSHEET.CELLS(i,8).VALUE = Allt(Ten_kh)
		XLSHEET.CELLS(i,9).VALUE = "'"+allt(Ma_so_thue)
		XLSHEET.CELLS(i,10).VALUE = allt(Ten_vt)
		XLSHEET.CELLS(i,11).VALUE = t_tien
		XLSHEET.CELLS(i,12).VALUE = thue_suat
		XLSHEET.CELLS(i,13).VALUE = t_thue
		XLSHEET.CELLS(i,14).VALUE = allt(ghi_chu)
	ENDSCAN
	
	n=0
	
	k = q + 3 + d2
	
	i = p + 3 + d2
	
	p = i
	q = k
	
	d3 = 0

	SELECT tThueTmp
	SCAN for allt(nhom) = '3'
		i=i+1
		n=n+1
		
		if i>k and d3 < t3
			d3 = d3 + 1
			CROW = ALLTRIM(STR(i))
		    XlSheet.Rows("&cRow:&cRow").Insert
		endif
		
		XLSHEET.CELLS(i,2).VALUE = "'"+allt(str(n))
		XLSHEET.CELLS(i,3).VALUE = allt(Ma_hdon)
		XLSHEET.CELLS(i,4).VALUE = allt(kh_mhd)
		XLSHEET.CELLS(i,5).VALUE = allt(so_seri0)
		XLSHEET.CELLS(i,6).VALUE = "'"+allt(so_ct0)
		XLSHEET.CELLS(i,7).VALUE = ngay_ct0
		XLSHEET.CELLS(i,8).VALUE = Allt(Ten_kh)
		XLSHEET.CELLS(i,9).VALUE = "'"+allt(Ma_so_thue)
		XLSHEET.CELLS(i,10).VALUE = allt(Ten_vt)
		XLSHEET.CELLS(i,11).VALUE = t_tien
		XLSHEET.CELLS(i,12).VALUE = thue_suat
		XLSHEET.CELLS(i,13).VALUE = t_thue
		XLSHEET.CELLS(i,14).VALUE = allt(ghi_chu)
	ENDSCAN
	
	n=0
	
	k = q + 3 + d3
	
	i = p + 3 + d3
	
	p = i
	q = k
	
	d4 = 0
	
	SELECT tThueTmp
	SCAN for allt(nhom) = '4'
		i=i+1
		n=n+1
		
		if i>k and d4 < t4
			d4 = d4 + 1
			CROW = ALLTRIM(STR(i))
		    XlSheet.Rows("&cRow:&cRow").Insert
		endif
		
		XLSHEET.CELLS(i,2).VALUE = "'"+allt(str(n))
		XLSHEET.CELLS(i,3).VALUE = allt(Ma_hdon)
		XLSHEET.CELLS(i,4).VALUE = allt(kh_mhd)
		XLSHEET.CELLS(i,5).VALUE = allt(so_seri0)
		XLSHEET.CELLS(i,6).VALUE = "'"+allt(so_ct0)
		XLSHEET.CELLS(i,7).VALUE = ngay_ct0
		XLSHEET.CELLS(i,8).VALUE = Allt(Ten_kh)
		XLSHEET.CELLS(i,9).VALUE = "'"+allt(Ma_so_thue)
		XLSHEET.CELLS(i,10).VALUE = allt(Ten_vt)
		XLSHEET.CELLS(i,11).VALUE = t_tien
		XLSHEET.CELLS(i,12).VALUE = thue_suat
		XLSHEET.CELLS(i,13).VALUE = t_thue
		XLSHEET.CELLS(i,14).VALUE = allt(ghi_chu)
	ENDSCAN
	
	n=0
	
	k = q + 3 + d4
	
	i = p + 3 + d4
	
	d5 = 0
	
	SELECT tThueTmp
	SCAN for allt(nhom) = '5'
		i=i+1
		n=n+1
		
		if i>k and d5 < t5
			d5 = d5 + 1
			CROW = ALLTRIM(STR(i))
		    XlSheet.Rows("&cRow:&cRow").Insert
		endif
		
		XLSHEET.CELLS(i,2).VALUE = "'"+allt(str(n))
		XLSHEET.CELLS(i,3).VALUE = allt(Ma_hdon)
		XLSHEET.CELLS(i,4).VALUE = allt(kh_mhd)
		XLSHEET.CELLS(i,5).VALUE = allt(so_seri0)
		XLSHEET.CELLS(i,6).VALUE = "'"+allt(so_ct0)
		XLSHEET.CELLS(i,7).VALUE = ngay_ct0
		XLSHEET.CELLS(i,8).VALUE = Allt(Ten_kh)
		XLSHEET.CELLS(i,9).VALUE = "'"+allt(Ma_so_thue)
		XLSHEET.CELLS(i,10).VALUE = allt(Ten_vt)
		XLSHEET.CELLS(i,11).VALUE = t_tien
		XLSHEET.CELLS(i,12).VALUE = thue_suat
		XLSHEET.CELLS(i,13).VALUE = t_thue
		XLSHEET.CELLS(i,14).VALUE = allt(ghi_chu)
	ENDSCAN
	
	
	_Temsaveas = PUTFILE('xls')
	XLSHEET.SAVEAS(_Temsaveas)

RETURN
